uniform sampler2D texture;
uniform sampler2D normalMapTexture;

varying vec3 L;
varying vec3 V;

void main()
{
  vec3 N = texture2D(normalMapTexture, vec2(gl_TexCoord[0])).xyz;
  
  N = (N - vec3(0.5, 0.5, 0.5))*2.0;
  
  N = normalize(N);
  
  vec3 R = normalize(-reflect(L,N));

  float Idiff = max(dot(N,L), 0.0);
  float ISpec = pow(max(dot(R,V),0.0),0.3 * gl_FrontMaterial.shininess);
  
  
  vec4 color = texture2D(texture, vec2(gl_TexCoord[0])) * (Idiff + ISpec + 0.3);
  
  color.w = 1.0;
  gl_FragColor = color;  
}