uniform mat4 lightMatrix;

varying vec3 L;
varying vec3 V;


void main()
{
   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
   gl_TexCoord[0]  = gl_MultiTexCoord0;
   
   vec3 T;
   vec3 B;
   vec3 N;
   
   T.x = 1.0;
   T.y = 0.0;
   T.z = 0.0;
   
   N = normalize(gl_NormalMatrix * gl_Normal);     
   
   B = cross(T, N);
   
   vec3 lightPos = vec3(lightMatrix * gl_LightSource[0].position);
   
   vec3 eye = vec3(gl_ModelViewMatrix * gl_Vertex);
   
   vec3 lightVec = normalize(lightPos - eye);
   
   vec3 eyeVec = -eye;
   
   V.x = dot(eyeVec, T);
   V.y = dot(eyeVec, B);
   V.z = dot(eyeVec, N);
   V = normalize(V);
   
   
   L.x = dot(lightVec, T);
   L.y = dot(lightVec, B);
   L.z = dot(lightVec, N);
   L = normalize(L);
}